#include "ydExample.h"

class YDExample1Listener: public YDListener
{
private:
	YDApi *m_pApi;
	const char *m_username,*m_password,*m_instrumentID;
	int m_maxPosition;
	int m_maxOrderRef;

	// ָϣ׵Ʒ
	const YDInstrument *m_pInstrument;

	// ָϣ׵Ʒֵ˻ƷϢ
	const YDAccountInstrumentInfo *m_pAccountInstrumentInfo;

	// ˵ǰǷйҵ
	bool m_hasOrder;
public:
	YDExample1Listener(YDApi *pApi,const char *username,const char *password,const char *instrumentID,int maxPosition)
	{
		m_pApi=pApi;
		m_username=username;
		m_password=password;
		m_instrumentID=instrumentID;
		m_maxPosition=maxPosition;
		m_maxOrderRef=0;
		m_hasOrder=false;
	}
	virtual void notifyReadyForLogin(bool hasLoginFailed)
	{
		// API׼¼ʱϢûҪڴʱ¼ָ
		// ˶ҲᷢϢû·¼ָǴʱû¼
		if (!m_pApi->login(m_username,m_password,NULL,NULL))
		{
			printf("can not login\n");
			exit(1);
		}
	}
	virtual void notifyLogin(int errorNo, int maxOrderRef, bool isMonitor)
	{
		// ÿε¼ӦôϢûӦerrorNoжǷ¼ɹ
		if (errorNo==0)
		{
			// ¼ɹӦ¼ǰ󱨵ãڱʱøΪãԱͨʶ𱨵
			m_maxOrderRef=maxOrderRef;
			printf("login successfully\n");
		}
		else
		{
			// ¼ʧܣпǷδԿѡֹ򣬵ǲҪٴη¼
			// ApiԹһٴθnotifyReadyForLoginϢӦʱ¼
			printf("login failed, errorNo=%d\n",errorNo);
			exit(1);
		}
	}
	virtual void notifyFinishInit(void)
	{
		// notifyFinishInitڵһε¼ɹһСʱ䷢ϢʾAPIѾյ˽гʼϢ
		// еĲƷԼϢͽյĹ̶飨ǵͣ壩Ϣ˺ŵճϢ֤Ϣ
		// ϢֲϢǻûлõ¼ǰѾıͳɽϢڵĳϢ
		// ʱûѾ԰ȫطAPIݽṹ
		// ûYDSystemParamYDExchangeYDProductYDInstrumentYDCombPositionDefYDAccount
		// YDPrePositionYDMarginRateYDCommissionRateYDAccountExchangeInfoYDAccountProductInfo
		// YDAccountInstrumentInfoYDMarketDataָ룬δڰȫʹãAPIıַ
		// APIϢеYDOrderYDTradeYDInputOrderYDQuoteYDInputQuoteYDCombPositionĵַ
		// ʱģڸϢɺ󽫲Ч
		m_pInstrument=m_pApi->getInstrumentByID(m_instrumentID);
		if (m_pInstrument==NULL)
		{
			printf("can not find instrument %s\n",m_instrumentID);
			exit(1);
		}
		m_pAccountInstrumentInfo=m_pApi->getAccountInstrumentInfo(m_pInstrument);
		// ѭչʾθʷֲϢƷֵĵǰֲ֡ûغʷֲ֣Բʹ
		for (int i=0;i<m_pApi->getPrePositionCount();i++)
		{
			const YDPrePosition *pPrePosition=m_pApi->getPrePosition(i);
			if (pPrePosition->m_pInstrument==m_pInstrument)
			{
				if (pPrePosition->PositionDirection==YD_PD_Long)
				{
					// иṹеUserInt1UserInt2UserFloatpUserǹûʹõģֵ0
					// ڱУʹ˻ԼϢеUserInt1浱ǰĳֲϢ
					m_pAccountInstrumentInfo->UserInt1+=pPrePosition->PrePosition;
				}
				else
				{
					m_pAccountInstrumentInfo->UserInt1-=pPrePosition->PrePosition;
				}
			}
		}
		printf("Position=%d\n",m_pAccountInstrumentInfo->UserInt1);
		m_pApi->subscribe(m_pInstrument);
	}
	virtual void notifyMarketData(const YDMarketData *pMarketData)
	{
		if (m_pInstrument->m_pMarketData!=pMarketData)
		{
			// ڸƷֵpMarketDataĵַǹ̶ģԿô˷ԷǱƷֵ
			return;
		}
		if ((pMarketData->AskVolume==0)||(pMarketData->BidVolume==0))
		{
			// ͣ
			return;
		}
		if (pMarketData->BidVolume-pMarketData->AskVolume>100)
		{
			// ݲҪ
			tryTrade(YD_D_Buy);
		}
		else if (pMarketData->AskVolume-pMarketData->BidVolume>100)
		{
			// ݲҪ
			tryTrade(YD_D_Sell);
		}
	}
	void tryTrade(int direction)
	{
		if (m_hasOrder)
		{
			// йҵͲ
			return;
		}
		YDInputOrder inputOrder;
		// inputOrderевõֶΣӦͳһ0
		memset(&inputOrder,0,sizeof(inputOrder));
		if (direction==YD_D_Buy)
		{
			if (m_pAccountInstrumentInfo->UserInt1>=m_maxPosition)
			{
				// Ƿﵽ޲
				return;
			}
			if (m_pAccountInstrumentInfo->UserInt1>=0)
			{
				// ƿƽ֣ûдSHFEINEֵֽ
				inputOrder.OffsetFlag=YD_OF_Open;
			}
			else
			{
				inputOrder.OffsetFlag=YD_OF_Close;
			}
			// ڱʹõĲм۵Ҫָ۸
			inputOrder.Price=m_pInstrument->m_pMarketData->AskPrice;
		}
		else
		{
			if (m_pAccountInstrumentInfo->UserInt1<=-m_maxPosition)
			{
				return;
			}
			if (m_pAccountInstrumentInfo->UserInt1<=0)
			{
				inputOrder.OffsetFlag=YD_OF_Open;
			}
			else
			{
				inputOrder.OffsetFlag=YD_OF_Close;
			}
			inputOrder.Price=m_pInstrument->m_pMarketData->BidPrice;
		}
		inputOrder.Direction=direction;
		inputOrder.HedgeFlag=YD_HF_Speculation;
		inputOrder.OrderVolume=1;
		// ʹһһáYDOrderRefֻǽڱͳɽرз
		// ûѡOrderRefı뷽ʽ
		// ڷǱϵͳвıϵͳصOrderRefһ-1
		// YDClientıOrderRefһ0
		inputOrder.OrderRef=++m_maxOrderRef;
		// ʹ޼۵
		inputOrder.OrderType=YD_ODT_Limit;
		// ˵ͨ
		inputOrder.YDOrderFlag=YD_YOF_Normal;
		// ˵ѡ
		inputOrder.ConnectionSelectionType=YD_CS_Any;
		// ConnectionSelectionTypeYD_CS_AnyҪָConnectionIDΧ0ӦYDExchangeеConnectionCount-1
		inputOrder.ConnectionID=0;
		// inputOrderеRealConnectionIDErrorNoڷʱɷд
		if (m_pApi->insertOrder(&inputOrder,m_pInstrument))
		{
			m_hasOrder=true;
		}
	}
	virtual void notifyOrder(const YDOrder *pOrder, const YDInstrument *pInstrument, const YDAccount *pAccount)
	{
		if (pOrder->OrderStatus==YD_OS_Queuing)
		{
			// ڹҵֱӳ
			// inputOrderOrderTypeYD_ODT_LimitǾͲҪγ߼
			YDCancelOrder cancelOrder;
			memset(&cancelOrder,0,sizeof(cancelOrder));
			cancelOrder.LongOrderSysID=pOrder->LongOrderSysID;
			//ϵͳûгintıʾΧʱҲʹ
			//cancelOrder.OrderSysID=pOrder->OrderSysID;
			m_pApi->cancelOrder(&cancelOrder,pInstrument->m_pExchange,pAccount);
		}
		else
		{
			m_hasOrder=false;
		}
	}
	virtual void notifyTrade(const YDTrade *pTrade, const YDInstrument *pInstrument, const YDAccount *pAccount)
	{
		if (pTrade->Direction==YD_D_Buy)
		{
			// ݳɽֲ
			m_pAccountInstrumentInfo->UserInt1+=pTrade->Volume;
		}
		else
		{
			m_pAccountInstrumentInfo->UserInt1-=pTrade->Volume;
		}
		printf("%s %s %d at %g\n",(pTrade->Direction==YD_D_Buy?"buy":"sell"),(pTrade->OffsetFlag==YD_OF_Open?"open":"close"),pTrade->Volume,pTrade->Price);
		printf("Position=%d\n",m_pAccountInstrumentInfo->UserInt1);
	}
};

void startExample1(const char *configFilename,const char *username,const char *password,const char *instrumentID)
{
	/// YDApi

	// YDApi
	YDApi *pApi=makeYDApi(configFilename);
	if (pApi==NULL)
	{
		printf("can not create API\n");
		exit(1);
	}
	// Apiļ
	YDExample1Listener *pListener=new YDExample1Listener(pApi,username,password,instrumentID,3);
	/// Api
	if (!pApi->start(pListener))
	{
		printf("can not start API\n");
		exit(1);
	}
}
