#include <map>
#include "ydExample.h"

class YDExample3Listener: public YDListener
{
private:
	static int getFrozenVolume(const YDOrder *pOrder) 
	{
		if ((pOrder!=NULL)&&!isOrderFinished(pOrder->OrderStatus))
		{
			return pOrder->OrderVolume-pOrder->TradeVolume;
		}
		else
		{
			return 0;
		}
	}
	static int getTradeVolume(const YDOrder *pOrder)
	{
		if (pOrder!=NULL)
		{
			return pOrder->TradeVolume;
		}
		else
		{
			return 0;
		}
	}
	class CStrategyPosition
	{
	public:
		// m_positionݳɽرĳֲ
		int m_position;
		// m_positionByOrderݱرĳֲ
		int m_positionByOrder;
		int m_openFrozen;
		int m_closeFrozen;

		CStrategyPosition(void)
		{
			memset(this,0,sizeof(*this));
		}
		// зʹm_positionByOrderǲʹm_position㣬Ϊϵͳյرͳɽر֮һСļ
		// ȸرǱϵͳѾضڳɽرûʹǰбܴжϴ
		bool canClose(int volume) const
		{
			return m_positionByOrder-m_closeFrozen>=volume;
		}
		bool canOpen(int volume,int maxPosition) const
		{
			return (m_positionByOrder+m_openFrozen+volume)<=maxPosition;
		}
		void refresh(int tradeVolumeChange,int frozenVolumeChange,bool isOpen)
		{
			if (isOpen)
			{
				m_positionByOrder+=tradeVolumeChange;
				m_openFrozen+=frozenVolumeChange;
			}
			else
			{
				m_positionByOrder-=tradeVolumeChange;
				m_closeFrozen+=frozenVolumeChange;
			}
		}
		void refreshByOrder(const YDOrder *pNewOrder,const YDOrder *pOldOrder)
		{
			refresh(getTradeVolume(pNewOrder)-getTradeVolume(pOldOrder),getFrozenVolume(pNewOrder)-getFrozenVolume(pOldOrder),
				pNewOrder->OffsetFlag==YD_OF_Open);
		}
		void refreshFirstTimeByOrder(const YDOrder *pNewOrder,const YDInputOrder *pInputOrder)
		{
			refresh(getTradeVolume(pNewOrder),getFrozenVolume(pNewOrder)-pInputOrder->OrderVolume,
				pNewOrder->OffsetFlag==YD_OF_Open);
		}
		void refreshByInputOrder(const YDInputOrder *pInputOrder)
		{
			refresh(0,pInputOrder->OrderVolume,pInputOrder->OffsetFlag==YD_OF_Open);
		}
	};

	YDApi *m_pApi;
	const char *m_username,*m_password,*m_instrumentID;
	int m_maxPosition;
	int m_maxOrderRef;
	bool m_hasCaughtUp;

	// ָϣ׵Ʒ
	const YDInstrument *m_pInstrument;

	// ֲ֣±0Ӧ룬±1Ӧ
	CStrategyPosition m_positions[2];

	/// ǰеĹҵOrderSysID->YDOrder
	std::map<int,YDOrder> m_pendingOrders;

	/// ǰбǻûյرı
	std::map<int,YDInputOrder> m_pendingSentOrders;

	static int getPositionID(int direction,int offsetFlag)
	{
		if (direction==YD_OF_Open)
		{
			if (offsetFlag==YD_OF_Open)
			{
				return 0;
			}
			else
			{
				return 1;
			}
		}
		else
		{
			if (offsetFlag==YD_OF_Open)
			{
				return 1;
			}
			else
			{
				return 0;
			}
		}
	}
	static bool isOrderFinished(int orderStatus)
	{
		return orderStatus>=YD_OS_Canceled;
	}
	void updateOrder(const YDOrder *pOrder)
	{
		YDOrder *pOldOrder;
		std::map<int,YDInputOrder>::iterator iit=m_pendingSentOrders.find(pOrder->OrderRef);
		if (iit!=m_pendingSentOrders.end())
		{
			m_positions[getPositionID(pOrder->Direction,pOrder->OffsetFlag)].refreshFirstTimeByOrder(pOrder,&iit->second);
			m_pendingSentOrders.erase(iit);
			pOldOrder=NULL;
		}
		else
		{
			std::map<int,YDOrder>::iterator it=m_pendingOrders.find(pOrder->OrderSysID);
			if (it==m_pendingOrders.end())
			{
				pOldOrder=NULL;
			}
			else
			{
				pOldOrder=&(it->second);
			}
			m_positions[getPositionID(pOrder->Direction,pOrder->OffsetFlag)].refreshByOrder(pOrder,pOldOrder);
		}
		if (isOrderFinished(pOrder->OrderStatus))
		{
			if (pOldOrder!=NULL)
			{
				m_pendingOrders.erase(pOrder->OrderSysID);
			}
		}
		else
		{
			m_pendingOrders[pOrder->OrderSysID]=*pOrder;
		}
	}
	void addTrade(const YDTrade *pTrade)
	{
		int positionChange;
		if (pTrade->OffsetFlag==YD_OF_Open)
		{
			positionChange=pTrade->Volume;
		}
		else
		{
			positionChange=-pTrade->Volume;
		}
		m_positions[getPositionID(pTrade->Direction,pTrade->OffsetFlag)].m_position+=positionChange;
	}

public:
	YDExample3Listener(YDApi *pApi,const char *username,const char *password,const char *instrumentID,int maxPosition)
	{
		m_pApi=pApi;
		m_username=username;
		m_password=password;
		m_instrumentID=instrumentID;
		m_maxPosition=maxPosition;
		m_maxOrderRef=0;
		m_hasCaughtUp=false;
	}
	virtual void notifyReadyForLogin(bool hasLoginFailed)
	{
		// API׼¼ʱϢûҪڴʱ¼ָ
		// ˶ҲᷢϢû·¼ָǴʱû¼
		if (!m_pApi->login(m_username,m_password,NULL,NULL))
		{
			printf("can not login\n");
			exit(1);
		}
		m_hasCaughtUp=false;
	}
	virtual void notifyLogin(int errorNo, int maxOrderRef, bool isMonitor)
	{
		// ÿε¼ӦôϢûӦerrorNoжǷ¼ɹ
		if (errorNo==0)
		{
			// ¼ɹӦ¼ǰ󱨵ãڱʱøΪãԱͨʶ𱨵
			m_maxOrderRef=maxOrderRef;
			printf("login successfully\n");
		}
		else
		{
			// ¼ʧܣпǷδԿѡֹ򣬵ǲҪٴη¼
			// ApiԹһٴθnotifyReadyForLoginϢӦʱ¼
			printf("login failed, errorNo=%d\n",errorNo);
			exit(1);
		}
	}
	virtual void notifyFinishInit(void)
	{
		// notifyFinishInitڵһε¼ɹһСʱ䷢ϢʾAPIѾյ˽гʼϢ
		// еĲƷԼϢͽյĹ̶飨ǵͣ壩Ϣ˺ŵճϢ֤Ϣ
		// ϢֲϢǻûлõ¼ǰѾıͳɽϢڵĳϢ
		// ʱûѾ԰ȫطAPIݽṹ
		// ûYDSystemParamYDExchangeYDProductYDInstrumentYDCombPositionDefYDAccount
		// YDPrePositionYDMarginRateYDCommissionRateYDAccountExchangeInfoYDAccountProductInfo
		// YDAccountInstrumentInfoYDMarketDataָ룬δڰȫʹãAPIıַ
		// APIϢеYDOrderYDTradeYDInputOrderYDQuoteYDInputQuoteYDCombPositionĵַ
		// ʱģڸϢɺ󽫲Ч
		m_pInstrument=m_pApi->getInstrumentByID(m_instrumentID);
		if (m_pInstrument==NULL)
		{
			printf("can not find instrument %s\n",m_instrumentID);
			exit(1);
		}
		m_pApi->subscribe(m_pInstrument);
	}
	virtual void notifyCaughtUp(void)
	{
		// յϢ˵ͻѾ׷˷˵Ϣ
		// м䷢ߣҪãnotifyReadyForLoginȷٴ׷
		m_hasCaughtUp=true;
	}
	virtual void notifyMarketData(const YDMarketData *pMarketData)
	{
		if (m_pInstrument->m_pMarketData!=pMarketData)
		{
			// ڸƷֵpMarketDataĵַǹ̶ģԿô˷ԷǱƷֵ
			return;
		}
		if (!m_hasCaughtUp)
		{
			// û׷ϢǳֲֿǴģԷ
			return;
		}
		if ((pMarketData->AskVolume==0)||(pMarketData->BidVolume==0))
		{
			// ͣ
			return;
		}
		if (pMarketData->BidVolume-pMarketData->AskVolume>100)
		{
			// ݲҪ
			tryTrade(YD_D_Buy);
		}
		else if (pMarketData->AskVolume-pMarketData->BidVolume>100)
		{
			// ݲҪ
			tryTrade(YD_D_Sell);
		}
	}
	void tryTrade(int direction)
	{
		YDInputOrder inputOrder;
		// inputOrderевõֶΣӦͳһ0
		memset(&inputOrder,0,sizeof(inputOrder));
		if (direction==YD_D_Buy)
		{
			if (m_positions[1].canClose(1))
			{
				// ȸݿͷλǷƽ֣SHFEINEӦƽƽ
				inputOrder.OffsetFlag=YD_OF_Close;
			}
			else if (m_positions[0].canOpen(1,m_maxPosition))
			{
				// ٸݶͷλǷԿ
				inputOrder.OffsetFlag=YD_OF_Open;
			}
			else
			{
				return;
			}
			// ڱʹõĲм۵Ҫָ۸
			inputOrder.Price=m_pInstrument->m_pMarketData->AskPrice;
		}
		else
		{
			if (m_positions[0].canClose(1))
			{
				// ȸݶͷλǷƽ֣SHFEINEӦƽƽ
				inputOrder.OffsetFlag=YD_OF_Close;
			}
			else if (m_positions[1].canOpen(1,m_maxPosition))
			{
				// ٸݿͷλǷԿ
				inputOrder.OffsetFlag=YD_OF_Open;
			}
			else
			{
				return;
			}
			inputOrder.Price=m_pInstrument->m_pMarketData->BidPrice;
		}
		inputOrder.Direction=direction;
		inputOrder.HedgeFlag=YD_HF_Speculation;
		inputOrder.OrderVolume=1;
		// ʹһһáYDOrderRefֻǽڱͳɽرз
		// ûѡOrderRefı뷽ʽ
		// ڷǱϵͳвıϵͳصOrderRefһ-1
		// YDClientıOrderRefһ0
		inputOrder.OrderRef=++m_maxOrderRef;
		// ʹ޼۵
		inputOrder.OrderType=YD_ODT_Limit;
		// ˵ͨ
		inputOrder.YDOrderFlag=YD_YOF_Normal;
		// ˵ѡ
		inputOrder.ConnectionSelectionType=YD_CS_Any;
		// ConnectionSelectionTypeYD_CS_AnyҪָConnectionIDΧ0ӦYDExchangeеConnectionCount-1
		inputOrder.ConnectionID=0;
		// inputOrderеRealConnectionIDErrorNoڷʱɷд
		if (m_pApi->insertOrder(&inputOrder,m_pInstrument))
		{
			m_pendingSentOrders[inputOrder.OrderRef]=inputOrder;
			m_positions[getPositionID(inputOrder.Direction,inputOrder.OffsetFlag)].refreshByInputOrder(&inputOrder);
		}
	}
	virtual void notifyOrder(const YDOrder *pOrder, const YDInstrument *pInstrument, const YDAccount *pAccount)
	{
		updateOrder(pOrder);
		if (pOrder->OrderStatus==YD_OS_Queuing)
		{
			// ڹҵֱӳ
			// inputOrderOrderTypeYD_ODT_LimitǾͲҪγ߼
			YDCancelOrder cancelOrder;
			memset(&cancelOrder,0,sizeof(cancelOrder));
			cancelOrder.OrderSysID=pOrder->OrderSysID;
			m_pApi->cancelOrder(&cancelOrder,pInstrument->m_pExchange,pAccount);
		}
	}
	virtual void notifyTrade(const YDTrade *pTrade, const YDInstrument *pInstrument, const YDAccount *pAccount)
	{
		addTrade(pTrade);
	}
};

void startExample3(const char *configFilename,const char *username,const char *password,const char *instrumentID)
{
	/// YDApi

	// YDApi
	YDApi *pApi=makeYDApi(configFilename);
	if (pApi==NULL)
	{
		printf("can not create API\n");
		exit(1);
	}
	// Apiļ
	YDExample3Listener *pListener=new YDExample3Listener(pApi,username,password,instrumentID,3);
	/// Api
	if (!pApi->start(pListener))
	{
		printf("can not start API\n");
		exit(1);
	}
}
