#include <map>
#include "ydExample.h"

class YDExample4Listener: public YDListener
{
private:
	YDExtendedApi *m_pApi;
	const char *m_username,*m_password,*m_instrumentID;
	int m_maxPosition;
	int m_maxOrderRef;
	bool m_hasCaughtUp;

	// ָϣ׵Ʒ
	const YDInstrument *m_pInstrument;

	static bool canClose(const YDExtendedPosition *pPosition,int volume)
	{
		if (pPosition==NULL)
		{
			// ûгֲּ¼˵ûв֣Բƽ
			return false;
		}
		// гֲּ¼
		return pPosition->PositionByOrder-pPosition->CloseFrozen>=volume;
	}
	static bool canOpen(const YDExtendedPosition *pPosition,int volume,int maxPosition)
	{
		if (pPosition==NULL)
		{
			// ûгֲּ¼˵ûв
			return volume<=maxPosition;
		}
		// гֲּ¼
		return pPosition->PositionByOrder+pPosition->OpenFrozen+volume<=maxPosition;
	}

	bool getOffsetFlag(int direction,int volume,char &offsetFlag) const
	{
		if (m_pInstrument->m_pExchange->UseTodayPosition)
		{
			///ֵֽSHFEINE
			if (direction==YD_D_Buy)
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseToday;
					return true;
				}
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseYesterday;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
			else
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseToday;
					return true;
				}
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseYesterday;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
		}
		else
		{
			///ֵֽ
			if (direction==YD_D_Buy)
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_Close;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
			else
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_Close;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
		}
		return false;
	}

public:
	YDExample4Listener(YDExtendedApi *pApi,const char *username,const char *password,const char *instrumentID,int maxPosition)
	{
		m_pApi=pApi;
		m_username=username;
		m_password=password;
		m_instrumentID=instrumentID;
		m_maxPosition=maxPosition;
		m_maxOrderRef=0;
		m_hasCaughtUp=false;
	}
	virtual void notifyReadyForLogin(bool hasLoginFailed)
	{
		// API׼¼ʱϢûҪڴʱ¼ָ
		// ˶ҲᷢϢû·¼ָǴʱû¼
		if (!m_pApi->login(m_username,m_password,NULL,NULL))
		{
			printf("can not login\n");
			exit(1);
		}
		m_hasCaughtUp=false;
	}
	virtual void notifyLogin(int errorNo, int maxOrderRef, bool isMonitor)
	{
		// ÿε¼ӦôϢûӦerrorNoжǷ¼ɹ
		if (errorNo==0)
		{
			// ¼ɹӦ¼ǰ󱨵ãڱʱøΪãԱͨʶ𱨵
			m_maxOrderRef=maxOrderRef;
			printf("login successfully\n");
		}
		else
		{
			// ¼ʧܣпǷδԿѡֹ򣬵ǲҪٴη¼
			// ApiԹһٴθnotifyReadyForLoginϢӦʱ¼
			printf("login failed, errorNo=%d\n",errorNo);
			exit(1);
		}
	}
	virtual void notifyFinishInit(void)
	{
		// notifyFinishInitڵһε¼ɹһСʱ䷢ϢʾAPIѾյ˽гʼϢ
		// еĲƷԼϢͽյĹ̶飨ǵͣ壩Ϣ˺ŵճϢ֤Ϣ
		// ϢֲϢǻûлõ¼ǰѾıͳɽϢڵĳϢ
		// ʱûѾ԰ȫطAPIݽṹ
		// ûYDSystemParamYDExchangeYDProductYDInstrumentYDCombPositionDefYDAccount
		// YDPrePositionYDMarginRateYDCommissionRateYDAccountExchangeInfoYDAccountProductInfo
		// YDAccountInstrumentInfoYDMarketDataָ룬δڰȫʹãAPIıַ
		// APIϢеYDOrderYDTradeYDInputOrderYDQuoteYDInputQuoteYDCombPositionĵַ
		// ʱģڸϢɺ󽫲Ч
		m_pInstrument=m_pApi->getInstrumentByID(m_instrumentID);
		if (m_pInstrument==NULL)
		{
			printf("can not find instrument %s\n",m_instrumentID);
			exit(1);
		}
		m_pApi->subscribe(m_pInstrument);
	}
	virtual void notifyCaughtUp(void)
	{
		// յϢ˵ͻѾ׷˷˵Ϣ
		// м䷢ߣҪãnotifyReadyForLoginȷٴ׷
		m_hasCaughtUp=true;
	}
	virtual void notifyMarketData(const YDMarketData *pMarketData)
	{
		if (m_pInstrument->m_pMarketData!=pMarketData)
		{
			// ڸƷֵpMarketDataĵַǹ̶ģԿô˷ԷǱƷֵ
			return;
		}
		if (!m_hasCaughtUp)
		{
			// û׷ϢǳֲֿǴģԷ
			return;
		}
		if ((pMarketData->AskVolume==0)||(pMarketData->BidVolume==0))
		{
			// ͣ
			return;
		}
		if (pMarketData->BidVolume-pMarketData->AskVolume>100)
		{
			// ݲҪ
			tryTrade(YD_D_Buy);
		}
		else if (pMarketData->AskVolume-pMarketData->BidVolume>100)
		{
			// ݲҪ
			tryTrade(YD_D_Sell);
		}
	}
	void tryTrade(int direction)
	{
		YDInputOrder inputOrder;
		// inputOrderевõֶΣӦͳһ0
		memset(&inputOrder,0,sizeof(inputOrder));
		if (!getOffsetFlag(direction,1,inputOrder.OffsetFlag))
		{
			return;
		}
		if (direction==YD_D_Buy)
		{
			// ڱʹõĲм۵Ҫָ۸
			inputOrder.Price=m_pInstrument->m_pMarketData->AskPrice;
		}
		else
		{
			inputOrder.Price=m_pInstrument->m_pMarketData->BidPrice;
		}
		inputOrder.Direction=direction;
		inputOrder.HedgeFlag=YD_HF_Speculation;
		inputOrder.OrderVolume=1;
		// ʹһһáYDOrderRefֻǽڱͳɽرз
		// ûѡOrderRefı뷽ʽ
		// ڷǱϵͳвıϵͳصOrderRefһ-1
		// YDClientıOrderRefһ0
		inputOrder.OrderRef=++m_maxOrderRef;
		// ʹ޼۵
		inputOrder.OrderType=YD_ODT_Limit;
		// ˵ͨ
		inputOrder.YDOrderFlag=YD_YOF_Normal;
		// ˵ѡ
		inputOrder.ConnectionSelectionType=YD_CS_Any;
		// ConnectionSelectionTypeYD_CS_AnyҪָConnectionIDΧ0ӦYDExchangeеConnectionCount-1
		inputOrder.ConnectionID=0;
		// inputOrderеRealConnectionIDErrorNoڷʱɷд
		m_pApi->insertOrder(&inputOrder,m_pInstrument);
		/*
		ҲʹָͱʱAPI˽зռ飬ʱ䣬ǳֲֹȷ
		m_pApi->checkAndInsertOrder(&inputOrder,m_pInstrument);
		ʹinsertOrderЧ൱Example2ʹcheckAndInsertOrderЧ൱Example3
		ʹcheckAndInsertOrderOrderRefʵAPIģûЧģֻɺȡ
		*/
	}
};

void startExample4(const char *configFilename,const char *username,const char *password,const char *instrumentID)
{
	/// YDApi

	// YDApi
	YDExtendedApi *pApi=makeYDExtendedApi(configFilename);
	if (pApi==NULL)
	{
		printf("can not create API\n");
		exit(1);
	}
	// Apiļ
	YDExample4Listener *pListener=new YDExample4Listener(pApi,username,password,instrumentID,3);
	/// Api
	if (!pApi->start(pListener))
	{
		printf("can not start API\n");
		exit(1);
	}
}
