#include <map>
#include "ydExample.h"

class YDExample6Listener: public YDListener
{
private:
	YDExtendedApi *m_pApi;
	const char *m_username,*m_password,*m_instrumentID;
	int m_maxPosition;
	int m_maxOrderRef;
	bool m_hasCaughtUp;

	// ָϣеƷ
	const YDInstrument *m_pInstrument;

	// ָı
	const YDExtendedQuote *m_pRecentQuote;

	// ˵۵ʱ
	int m_recentQuoteTime;

	// ǰʱ
	int m_curTime;

	// ǷûӦ۵ѯ
	bool m_hasRequestForQuote;

	static bool canClose(const YDExtendedPosition *pPosition,int volume)
	{
		if (pPosition==NULL)
		{
			// ûгֲּ¼˵ûв֣Բƽ
			return false;
		}
		// гֲּ¼
		return pPosition->PositionByOrder-pPosition->CloseFrozen>=volume;
	}
	static bool canOpen(const YDExtendedPosition *pPosition,int volume,int maxPosition)
	{
		if (pPosition==NULL)
		{
			// ûгֲּ¼˵ûв
			return volume<=maxPosition;
		}
		// гֲּ¼
		return pPosition->PositionByOrder+pPosition->OpenFrozen+volume<=maxPosition;
	}

	bool getOffsetFlag(int direction,int volume,char &offsetFlag) const
	{
		if (m_pInstrument->m_pExchange->UseTodayPosition)
		{
			///ֵֽSHFEINE
			if (direction==YD_D_Buy)
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseToday;
					return true;
				}
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseYesterday;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
			else
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseToday;
					return true;
				}
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_CloseYesterday;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_Today,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
		}
		else
		{
			///ֵֽ
			if (direction==YD_D_Buy)
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_Close;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
			else
			{
				if (canClose(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Long,YD_HF_Speculation,m_pInstrument),volume))
				{
					offsetFlag=YD_OF_Close;
					return true;
				}
				if (canOpen(m_pApi->getExtendedPosition(YD_PSD_History,YD_PD_Short,YD_HF_Speculation,m_pInstrument),volume,m_maxPosition))
				{
					offsetFlag=YD_OF_Open;
					return true;
				}
			}
		}
		return false;
	}

public:
	YDExample6Listener(YDExtendedApi *pApi,const char *username,const char *password,const char *instrumentID,int maxPosition)
	{
		m_pApi=pApi;
		m_username=username;
		m_password=password;
		m_instrumentID=instrumentID;
		m_maxPosition=maxPosition;
		m_maxOrderRef=0;
		m_hasCaughtUp=false;
		m_pRecentQuote=NULL;
		m_recentQuoteTime=0;
		m_curTime=0;
		m_hasRequestForQuote=false;
	}
	virtual void notifyReadyForLogin(bool hasLoginFailed)
	{
		// API׼¼ʱϢûҪڴʱ¼ָ
		// ˶ҲᷢϢû·¼ָǴʱû¼
		if (!m_pApi->login(m_username,m_password,NULL,NULL))
		{
			printf("can not login\n");
			exit(1);
		}
		m_hasCaughtUp=false;
	}
	virtual void notifyLogin(int errorNo, int maxOrderRef, bool isMonitor)
	{
		// ÿε¼ӦôϢûӦerrorNoжǷ¼ɹ
		if (errorNo==0)
		{
			// ¼ɹӦ¼ǰ󱨵ãڱʱøΪãԱͨʶ𱨵
			m_maxOrderRef=maxOrderRef;
			printf("login successfully\n");
		}
		else
		{
			// ¼ʧܣпǷδԿѡֹ򣬵ǲҪٴη¼
			// ApiԹһٴθnotifyReadyForLoginϢӦʱ¼
			printf("login failed, errorNo=%d\n",errorNo);
			exit(1);
		}
	}
	virtual void notifyFinishInit(void)
	{
		// notifyFinishInitڵһε¼ɹһСʱ䷢ϢʾAPIѾյ˽гʼϢ
		// еĲƷԼϢͽյĹ̶飨ǵͣ壩Ϣ˺ŵճϢ֤Ϣ
		// ϢֲϢǻûлõ¼ǰѾıͳɽϢڵĳϢ
		// ʱûѾ԰ȫطAPIݽṹ
		// ûYDSystemParamYDExchangeYDProductYDInstrumentYDCombPositionDefYDAccount
		// YDPrePositionYDMarginRateYDCommissionRateYDAccountExchangeInfoYDAccountProductInfo
		// YDAccountInstrumentInfoYDMarketDataָ룬δڰȫʹãAPIıַ
		// APIϢеYDOrderYDTradeYDInputOrderYDQuoteYDInputQuoteYDCombPositionĵַ
		// ʱģڸϢɺ󽫲Ч
		m_pInstrument=m_pApi->getInstrumentByID(m_instrumentID);
		if (m_pInstrument==NULL)
		{
			printf("can not find instrument %s\n",m_instrumentID);
			exit(1);
		}
		m_pApi->subscribe(m_pInstrument);
	}
	virtual void notifyCaughtUp(void)
	{
		// յϢ˵ͻѾ׷˷˵Ϣ
		// м䷢ߣҪãnotifyReadyForLoginȷٴ׷
		m_hasCaughtUp=true;
	}
	void refresh(int curTime)
	{
		m_curTime=curTime;
		if (!m_hasCaughtUp)
		{
			// û׷ϢǳֲֿǴģԷ
			return;
		}
		if ((m_pRecentQuote==NULL) || (m_pRecentQuote->BidOrderFinished&&m_pRecentQuote->AskOrderFinished))
		{
			// бۣ߸ñ۵бѾˣǾͷµı
			YDInputQuote inputQuote;
			// inputQuoteевõֶΣӦͳһ0
			memset(&inputQuote,0,sizeof(inputQuote));
			if (!getOffsetFlag(YD_D_Buy,1,inputQuote.BidOffsetFlag))
			{
				return;
			}
			inputQuote.BidHedgeFlag=YD_HF_Speculation;
			if (!getOffsetFlag(YD_D_Sell,1,inputQuote.AskOffsetFlag))
			{
				return;
			}
			inputQuote.AskHedgeFlag=YD_HF_Speculation;
			// ֱʹе۽бۣʵʵȻӦۼۼ
			if ((m_pInstrument->m_pMarketData->BidVolume==0)||(m_pInstrument->m_pMarketData->AskVolume==0))
			{
				return;
			}
			inputQuote.BidPrice=m_pInstrument->m_pMarketData->BidPrice;
			inputQuote.AskPrice=m_pInstrument->m_pMarketData->AskPrice;
			inputQuote.BidVolume=1;
			inputQuote.AskVolume=1;
			inputQuote.OrderRef=++m_maxOrderRef;
			inputQuote.YDQuoteFlag=0;
			if (m_hasRequestForQuote)
			{
				const YDExtendedRequestForQuote *pRFQ=m_pApi->getRequestForQuote(m_pInstrument);
				if (pRFQ!=NULL)
				{
					// ˵αӦ
					inputQuote.YDQuoteFlag=YD_YQF_ResponseOfRFQ;
				}
				m_hasRequestForQuote=false;
			}
			// ˵ѡ
			inputQuote.ConnectionSelectionType=YD_CS_Any;
			// ConnectionSelectionTypeYD_CS_AnyҪָConnectionIDΧ0ӦYDExchangeеConnectionCount-1
			inputQuote.ConnectionID=0;
			// inputQuoteеRealConnectionIDErrorNoڷʱɷд
			m_pApi->insertQuote(&inputQuote,m_pInstrument);
			/*
			ҲдinsertQuote
			if (m_pApi->checkAndInsertQuote(&inputQuote,m_pInstrument))
			{
				m_pRecentQuote=m_pApi->getQuote(inputQuote.OrderRef);
				m_recentQuoteTime=curTime;
			}
			ʹcheckAndInsertQuote
				API˷ռ飬ʱ䣬Ƿչȷ
				OrderRefʵAPIģûЧģֻɺȡ
				notifyQuoteϢûбҪˣΪѾҵm_pRecentQuote
			*/
		}
		else if ((curTime-m_recentQuoteTime>10)||m_hasRequestForQuote)
		{
			// δɵıۣұʱ䳬10룬Ǿͳñ
			// ѯۣҲñۣԱ±±
			YDCancelQuote cancelQuote;
			memset(&cancelQuote,0,sizeof(cancelQuote));
			cancelQuote.QuoteSysID=m_pRecentQuote->QuoteSysID;
			m_pApi->cancelQuote(&cancelQuote,m_pInstrument->m_pExchange);
		}
	}
	virtual void notifyQuote(const YDQuote *pQuote,const YDInstrument *pInstrument,const YDAccount *pAccount)
	{
		if (pInstrument!=m_pInstrument)
		{
			return;
		}
		if (pQuote->ErrorNo==YD_ERROR_NoError)
		{
			// ڱòеpQuoteʱģͨgetQuoteõYDExtendedQuoteָǳЧ
			m_pRecentQuote=m_pApi->getQuote(pQuote->QuoteSysID,pInstrument->m_pExchange);
			m_recentQuoteTime=m_curTime;
		}
		else
		{
			m_pRecentQuote=NULL;
		}
	}
	virtual void notifyRequestForQuote(const YDRequestForQuote *pRequestForQuote,const YDInstrument *pInstrument)
	{
		if (pInstrument!=m_pInstrument)
		{
			return;
		}
		m_hasRequestForQuote=true;
	}
};

void startExample6(const char *configFilename,const char *username,const char *password,const char *instrumentID)
{
	/// YDApi

	// YDApi
	YDExtendedApi *pApi=makeYDExtendedApi(configFilename);
	if (pApi==NULL)
	{
		printf("can not create API\n");
		exit(1);
	}
	// Apiļ
	YDExample6Listener *pListener=new YDExample6Listener(pApi,username,password,instrumentID,3);
	/// Api
	if (!pApi->start(pListener))
	{
		printf("can not start API\n");
		exit(1);
	}

	// ʵһ򵥵Ķʱ
	for (int curTime=1;;curTime++)
	{
#ifdef WINDOWS
		Sleep(1000);
#else
		usleep(1000000);
#endif
		pListener->refresh(curTime);
	}
}
